#ifndef _SZIMPLA_LANC_H
#define _SZIMPLA_LANC_H

/**
 *  \file szimla_lanc.h
 *
 *  Egyszerű, egész elemeket tartalmazó láncolt lista definiciói
 *  Nincs strázsa
 */

#include <iostream>

/**
 * Lánc elem struktúra
 */
struct Lanc_elem {
    int adat;               // adat
    Lanc_elem* kov;         // C++-ban a struktúra név típussá vált
};

/**
 * lanc_epit - láncolt lista elejére fűzi az új adatot
 * @param p - lista elejére mutató pointer
 * @param i - új adat
 * @return lista új eleje
 */
Lanc_elem* lanc_epit(Lanc_elem* p, int i);

/**
 * lanc_kiir - láncolt lista elemeit (adatait) stream-re írja
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
void lanc_kiir(std::ostream& os, const Lanc_elem* p);

/**
 * lanc_felszabadít - láncolt lista elemeit felszabadítja
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
void lanc_felszabadit(Lanc_elem* p);


/**
 * inserter a listához.
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
std::ostream& operator<<(std::ostream& os, const Lanc_elem& l);

#endif // _SZIMPLA_LANC_H
