/**
 *  \file szimla_lanc.cpp
 *
 *  Egyszerű, egész elemeket tartalmazó láncolt lista megvalósítása
 *  Nincs strázsa
 */

#include "szimpla_lanc.h"

/**
 * lanc_epit - láncolt lista elejére fűzi az új adatot
 * @param p - lista elejére mutató pointer
 * @param i - új adat
 * @return lista új eleje
 */
Lanc_elem* lanc_epit(Lanc_elem* p, int a) {
    Lanc_elem *uj = new Lanc_elem;
    uj->adat = a;
    uj->kov = p;
    return uj;
}

/**
 * lanc_kiir - láncolt lista elemeit (adatait) stream-re írja
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
void lanc_kiir(std::ostream& os, const Lanc_elem* p) {
    while (p != NULL) {
        os << p->adat << ' ';
        p = p->kov;
    }
}
/**
 * lanc_felszabadít - láncolt lista elemeit felszabadítja
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
void lanc_felszabadit(Lanc_elem *p) {
    while (p != NULL) {
        Lanc_elem *tmp = p->kov;
        delete p;
        p = tmp;
    }
}

/**
 * inserter a listához.
 * @param os - output stream
 * @param p - lista elejére mutató pointer
 */
std::ostream& operator<<(std::ostream& os, const Lanc_elem& l) {
    lanc_kiir(os, &l);
    return os;
}
