/*
 * Kivetelkezeles proba a memoriafoglalashoz.
 * Forditas:
 *    g++ -static mem_alloc.cpp -o mem_alloc
 *  a mem_hendler vltozathoz:
 *    g++ -static -DHANDLER mem_alloc.cpp -o mem_alloc
 *  a NULL pointeres vltozathoz (nem dob kivtelt)
 *    g++ -static -DNOTHROW mem_alloc.cpp -o mem_alloc
 * Futattas:
 *    (ulimit -d 24; ./mem_alloc; )
 *
 * Windows XP alatt nem erdemes kiprobalni,
 * mert felzabalja a teljes memoriat, s lelassul a rendsszer!
 * win 8.1 alatt megy.
 * win 7 alatt: ?
 *
 */
#include <iostream>
#include <cstdlib>

using std::cerr;
using std::endl;

void outOfMem() {
   cerr << "Nagy a baj" << endl;
   exit(1);
}

int main() {
#ifdef HANDLER
   std::set_new_handler(outOfMem);
#endif
   long db = 0;
   try {
      while(true) {
#ifndef NOTHROW
          double *p = new double[1022]; // ez kb 8Kb az uaral2-n
#else
          double *p = new (std::nothrow) double[1022]; // ez kb 8Kb az uaral2-n
	  if (p == NULL) break;
#endif
	  db++;
      }
   } catch (std::bad_alloc) {
      cerr << "Gaz van" << endl;
   }
   cerr << "Ennyi new sikerult:" << db << endl;
   return(0);
}

