/**
 * \file template.cpp
 *
 * Els elads sablonos pldi egybegyrva
 *
 * A USE_STRCOL s a MAX_SEC makrkkal szablyozhat, hogy
 * melyik vltozat legyen (ld. kommentek).
 */

#include <iostream>
#include <iomanip>
#include <cstring>
#include <locale>

// Segdmakr, hogy windows-e
#define WINX defined(WIN32) || defined(_WIN32) || defined(WIN64) || defined(_WIN64)

// Ha Windows, akkor a karakterkszlet llts miatt kell a windows.h
#if WINX
#include <windows.h>
#endif // WINX

#include "printm.h"
#include "template.hpp"

using std::cout;
using std::endl;

// Ezzel a makrval szablyozhat, hogy legyen-e specializci const char*-ra.
//#define MAX_SPEC

// Ezzel a makrval szablyozhat, hogy strcoll-t, vagy strcmp-t hasznljon.
#define USE_STRCOLL


#ifdef MAX_SPEC
template <>
const char* max(const char* a, const char* b) {
  #ifdef USE_STRCOLL
	return strcoll(a, b) < 0 ? b : a;
  #else
    return strcmp(a, b) < 0 ? b : a;
  #endif
}
#endif

bool strLess(const char *s1, const char *s2) {
  #ifdef USE_STRCOLL
	return strcoll(s1, s2) < 0;
  #else
    return strcmp(s1, s2) < 0;
  #endif
}

int main() {
    setlocale(LC_ALL, "");      // remlhetleg a nyelvi alapbellts hu_HU.UTF-8
#if WINX
    SetConsoleCP(1250);         // winx-en ez is kell
    SetConsoleOutputCP(1250);
#endif
#ifdef MAX_SPEC
    cout << "max-ot specializaljuk const char *-ra" << endl;
#else
    cout << "Nincs specializci" << endl;
#endif // MAX_SPEC

#ifdef USE_STRCOLL
    cout << "strcoll-t hasznlunk" << endl;
#else
    cout << "strcmp-t hasznlunk" << endl;
#endif // USE_STRCOLL

    _(cout << max<long>(2, 10) << endl);
    _(cout << max<double>(1, 3.14) << endl);
    _(cout << max(40, 50) << endl);
    _(cout << max("alma", "korte", strLess) << endl);
    _(cout << max("alma", "korte") << endl);
    _(cout << max("dm", "Bla") << endl);
    _(cout << max("dm", "Bla", strLess) << endl);

}

