﻿#ifndef _TEMPLATE_HPP
#define _TEMPLATE_HPP

/**
 * \file template.hpp
 *
 * második előadás sablonjai
 * Sablonokat tartalamazó header fájloknak .hpp kiterjesztést szokás adni.
*/

/**
 * max függvénysablon
 * Két paraméter közül a nagyobbat adja
 * A paraméterek között értelmezettnek kell lennie a < operátornak.
 * T-nek kell, hogy legyen másoló konstruktora.
 */
template <typename T>
T max(T a, T b) {
	return a < b ? b : a;
}

/**
 * max függvénysablon (túlterhelt változat)
 * Két paraméter közül a nagyobbat adja
 * A paramétereket a két paraméteres cmp függvénnyel hasonlítja össze.
 * A cmp(T, T) predikátumtól elvárjuk, hogy logikai környezetben
 * kiértékelhető legyen, és működjön a T típusra.
 * T-nek kell, hogy legyen másoló konstruktora.
 */
template <typename T, typename C>
T max(T a, T b, C cmp) {
	return cmp(a, b) ? b : a;
}

#endif // _TEMPLATE_HPP
